/* 
 * This file part of gsopcast - A gtk front-end of p2p tv sopcast.
 * http://lianwei3.googlepages.com/home2
 * Copyright (C) 2006 Wei Lian <lianwei3@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "header.h"
#include "sound.h"
extern GtkObject *adj_sound;
extern Sound *sound;

/////////////////////hareware related stuff
Sound::Sound()
{
    assert(snd_mixer_open(&mixer, 0) >= 0);
    snd_mixer_attach(mixer, "default");
    snd_mixer_selem_register(mixer, NULL, NULL);
    snd_mixer_load(mixer);

    pcm_element = snd_mixer_first_elem(mixer);
    pcm_element = snd_mixer_elem_next(pcm_element);
    pcm_element = snd_mixer_elem_next(pcm_element);

    long int a, b;
    long alsa_min_vol, alsa_max_vol;
    snd_mixer_selem_get_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_LEFT, &a);
    snd_mixer_selem_get_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_RIGHT, &b);

    snd_mixer_selem_get_playback_volume_range(pcm_element,
					      &alsa_min_vol,
					      &alsa_max_vol);
    snd_mixer_selem_set_playback_volume_range(pcm_element, 0, 100);

}

//-----------------------------------------------------
int Sound::sound_read()
{
    long ll, lr;
    snd_mixer_handle_events(mixer);
    snd_mixer_selem_get_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_LEFT, &ll);
    snd_mixer_selem_get_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_RIGHT, &lr);
    return (ll + lr) >> 1;
}


//-----------------------------------------------------
void Sound::sound_write(int leftright)
{
    snd_mixer_selem_set_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_LEFT,
					leftright);
    snd_mixer_selem_set_playback_volume(pcm_element,
					SND_MIXER_SCHN_FRONT_RIGHT,
					leftright);
}


//-----------------------------------------------------
Sound::~Sound()
{
    snd_mixer_close(mixer);
}


//-----------------------------------------------------
gboolean sound_timer(void *)
{
    int value = sound->sound_read();

    if (gtk_adjustment_get_value(GTK_ADJUSTMENT(adj_sound)) != value) {
	gtk_adjustment_set_value(GTK_ADJUSTMENT(adj_sound), value);
    }
    return TRUE;
}
